% Propagate forward

clear separimg obspattern   % for saving memory, and for when the image size has changed since last time

obssize = size(obs);
vert = obssize(1);
horiz = obssize(2);

obspattern(1,:) = reshape(obs(:,:,1),(vert*horiz),1)';
obspattern(2,:) = reshape(obs(:,:,2),(vert*horiz),1)';
obspattern(3,:) = 1;     % for the biases

for subnet=1:ninputs
   input2all{subnet} = weight12{subnet} * obspattern;
   output2all{subnet} = (2/pi) * atan(input2all{subnet});   % for arctangent sigmoids

   output3all{subnet} = weight23{subnet} * output2all{subnet} + weight13{subnet} * obspattern;
end

clear input2all output2all

separ(:,:,1) = reshape(output3all{1},vert,horiz,1);
separ(:,:,2) = reshape(output3all{2},vert,horiz,1);

clear output3all

separmin = min(min(separ));
separmax = max(max(separ));

separimg(:,:,1) = (separ(:,:,1) - separmin(1)) / (separmax(1) - separmin(1));
separimg(:,:,2) = (separ(:,:,2) - separmin(2)) / (separmax(2) - separmin(2));

clear separ

